
GET_PROPERTY(OV_PRINTED GLOBAL PROPERTY OV_TRIED_ThirdPartyGtecUnicornCAPI)


IF(WIN32)
	FIND_PATH(PATH_UNICORN Unicorn.dll PATHS ${LIST_DEPENDENCIES_PATH} PATH_SUFFIXES sdk_gtec_unicorn NO_DEFAULT_PATH)

	IF(PATH_UNICORN)
		OV_PRINT(OV_PRINTED "  Found Gtec Unicorn device API...")
		INCLUDE_DIRECTORIES(${PATH_UNICORN}/)
		TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${PATH_UNICORN}/unicorn.lib)

		INSTALL(PROGRAMS "${PATH_UNICORN}/Unicorn.dll" DESTINATION ${DIST_BINDIR})
		ADD_DEFINITIONS(-DTARGET_HAS_ThirdPartyGtecUnicron)
	ELSE(PATH_UNICORN)
		OV_PRINT(OV_PRINTED "  FAILED to find Gtec Unicorn device API (optional driver)")
	ENDIF(PATH_UNICORN)

ENDIF(WIN32)

IF (UNIX)
	SET(CMAKE_FIND_LIBRARY_SUFFIXES ".so")
	FIND_LIBRARY(Unicorn_Linux_LIBRARY NAMES "unicorn" PATHS "/usr/lib" "/usr/local/lib")
	IF(Unicorn_Linux_LIBRARY)
		OV_PRINT(OV_PRINTED "  Found Unicorn Linux C API...")
		OV_PRINT(OV_PRINTED "    [  OK  ] Third party lib ${Unicorn_Linux_LIBRARY}")
		ADD_DEFINITIONS(-DTARGET_HAS_ThirdPartyUnicornLinux)
		TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Unicorn_Linux_LIBRARY} )
		SET(OV_ThirdPartyUnicornLinux "YES")
	ELSE()
		OV_PRINT(OV_PRINTED "  FAILED to find libunicorn Linux Unicorn API... (optional)")
	ENDIF()
ENDIF(UNIX)

SET_PROPERTY(GLOBAL PROPERTY OV_TRIED_ThirdPartyGtecUnicornCAPI "Yes")

